// BuildSvc.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <windows.h>

int main(int argc, char* argv[])
{
	SC_HANDLE   schSCManager;
	SC_HANDLE   schService;

	if( argc < 3 )
	{
		printf( "[]\n" );
		printf( "BuildSvc.EXE [SERVICENAME] [SERVICEDRIVER's FULLPATHNAME] [R]\n" );
		printf( "[SERVICENAME] :  ̸\n" );
		printf( "[SERVICEDRIVER's FULLPATHNAME] : ̹ ִ FullPath\n" );
		printf( "[R] : 񽺸 ڵ ϴ (ϸ   ʴ´)\n" );
		return 0;
	}
	schSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
	if (!schSCManager)
	{
		printf( "񽺸  ޴ ϴ\n" );
		return 0;
	}

	schService = OpenService(schSCManager, argv[1], SERVICE_ALL_ACCESS );
	if (schService == NULL) 
	{
		schService = CreateService(schSCManager, argv[1], argv[1], SERVICE_ALL_ACCESS, SERVICE_KERNEL_DRIVER, SERVICE_DEMAND_START
			, SERVICE_ERROR_NORMAL, argv[2], NULL, NULL, NULL, NULL, NULL);
		if (schService == NULL) 
		{
			printf( " 񽺴 ϵǾ ʴµ, ̻ϰԵ 񽺻 źεǰ ֽϴ\n" );
		}
		else
		{
			printf( " 񽺰 ϵ , 񽺰  Ǿϴ\n" );
			unsigned char * pTemp;
			pTemp = (unsigned char * )argv[3];
			
			if( ( argc > 3 ) && (( pTemp[0] == 'R' ) || ( pTemp[0] == 'r' )) )
			{
				BOOLEAN bRet = StartService(schService, 0, NULL ); // DriverEntry ȣȴ
				if( bRet == FALSE )
					printf( "񽺰 ɼ ϴ\n" );
				else
					printf( "񽺰 Ǿϴ\n" );
			}
			CloseServiceHandle(schService);
		}
	}
	else
	{
		printf( "񽺰 ̹ϱ⶧ 񽺻    մϴ\n" );
		unsigned char * pTemp;
		pTemp = (unsigned char * )argv[3];
		if( ( argc > 3 ) && (( pTemp[0] == 'R' ) || ( pTemp[0] == 'r' )) )
		{
			BOOLEAN bRet = StartService(schService, 0, NULL ); // DriverEntry ȣȴ
			if( bRet == FALSE )
				printf( "񽺰 ɼ ϴ\n" );
			else
				printf( "񽺰 Ǿϴ\n" );
		}
		CloseServiceHandle(schService);
	}
	CloseServiceHandle(schSCManager);

	return 0;
}
