#include <ntddk.h>

#ifndef _TH_HOOK_H_
#define  _TH_HOOK_H_

// ũ ϱ  Լ ID ο
#define MAX_FUNCTIONHOOK        (CODE_ID_MAX + 1)

#pragma pack(1)

//  ũ Լ  ũڵ带 ٷ ü
typedef struct _FUNCTIONHOOK {
    unsigned char *OrgFunctionAddress;      //  Լ ּ
    unsigned char *OrgFunctionAddressW;     //  Լ ּ(Writeable)
    int OrgFunctionSize;                    // Լ պκ ڵũ
    int OrgFunctionJmpSize;
    int OrgFunctionParameterCount;          // Լ Ķ 
    int JmpBuffer[0x10];                    // ڵ带 ɱ 
    int JmpBufferSize;                      // ڵ ũ
    unsigned char *FunctionHookWrapper;     // ũ Wrapper ּ
    unsigned char *CB;                      // CODE BLOCK ּ
    int CBSize;                             // CODE BLOCKũ
    unsigned char *CB_CreateStackFrame;     // Ʒ  Ե ڵ ּ
    unsigned char *CB_PushParams;
    unsigned char *CB_CallFunctionHookWrapper;
    unsigned char *CB_PopParams;
    unsigned char *CB_DeleteStackFrame;
    unsigned char *CB_RetXX;
    unsigned char *CB_OrgFunction;
    unsigned char *CB_OrgFunctionJmp;
} FUNCTIONHOOK, *PFUNCTIONHOOK, *FUNCTIONHOOKHANDLE;

// ũϱ  ޵Ǵ ü
typedef struct _APIPARAMS {
    FUNCTIONHOOKHANDLE h[MAX_FUNCTIONHOOK];
    BOOL bCodeHooked[MAX_FUNCTIONHOOK];
    int CodeID;
    BYTE CodeBuffer[MAX_FUNCTIONHOOK * 0x1000];
} APIPARAMS, *PAPIPARAMS;
//
#pragma pack()

unsigned char *GetRealAddress(unsigned char *JmpAddress);
int GetRelativeAddress(void *dst, void *cur);

BOOLEAN _cdecl KeInsertQueueDpcHookWrapper( PKDPC Dpc, PVOID Reserved1, PVOID Reserved2 );

void HookFunction(INT CodeId);
void HookKeInsertQueueDpc(INT CodeID, PVOID OrgAddr, PVOID OrgAddr2);
void UnHookKeInsertQueueDpc(INT CodeID);

#endif // _TH_HOOK_H_
