#include <NTDDK.H>

#include "logout.h"

ULONG LogoCount=0;
PLOGOENTRY LogoData;
ULONG ProcessNameOffset=0;
BOOLEAN CreateSign;

void InputLogo( char * LogoText, ULONG ProcessId, char * ProcessName, char * Document, int dwSize, ULONG Att )
{
	PLOGOENTRY pLogo;
	LARGE_INTEGER       ulldateTime;
	ULONG dateTime;

	if( CreateSign == FALSE )
		return;

       KeQuerySystemTime( &ulldateTime ); 

	pLogo = (PLOGOENTRY)LogoData;

	if( LogoCount >= MAXLOGOENTRY )
		return;

	pLogo += LogoCount;
	RtlZeroMemory( pLogo, sizeof(LOGOENTRY) );

	pLogo->CharType = ASCIITYPE;
	pLogo->ProcessId = ProcessId;
	RtlZeroMemory( pLogo->LogoText, MAXLOGOTEXTSIZE );
	memcpy( pLogo->LogoText, LogoText, strlen(LogoText) );
	memcpy( pLogo->ProcessName, ProcessName, strlen(ProcessName) );
	pLogo->dwAccessTime = (LONGLONG)ulldateTime.QuadPart;

	if( dwSize  )
		memcpy( pLogo->FullDocumentName, Document, strlen(Document) );
	
	pLogo->ProcessName[strlen(ProcessName)] = 0;
	pLogo->AccessResult = Att;
	LogoCount ++;
}

ULONG 
GetProcessNameOffset(
	VOID
	)
{
	PEPROCESS       curproc;
	int             i;

	curproc = PsGetCurrentProcess();

	for( i = 0; i < 3*4096; i++ ) {
	 
		if( !strncmp( "System", (char *) curproc + i, strlen("System") )) {

			return i;
		}
	}
	return 0;
}

char *
GetProcess( 
	char * ProcessName 
	)
{
	PEPROCESS       curproc;
	char            *nameptr;
	ULONG           i;

	curproc = (PEPROCESS)PsGetCurrentProcess(); 
	nameptr   = (char *) curproc + ProcessNameOffset;
	for( i = 0 ; i < 255 ; i ++ )
	{
		if(nameptr[i] == '.') 
			break;
		if(nameptr[i] == 0) 
			break;
	}
	
	strncpy( ProcessName, nameptr, i );
	ProcessName[i] = 0;
	return ProcessName;
}

void GetProcessName( char * pProcess )
{
	GetProcess( pProcess );
}

void cUpper(UCHAR *str)
{
	while(*str != 0)
	{
		if(*str >= 'a' && *str <= 'z')
			*str = 'A' + *str - 'a';
		str++;
	}
}

